package com.steerinfo.baseinfo.meterbasecarriercustomer.controller;

import com.steerinfo.baseinfo.meterbasecarriercustomer.model.MeterBaseCarrierCustomer;
import com.steerinfo.baseinfo.meterbasecarriercustomer.service.IMeterBaseCarrierCustomerService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseCarrierCustomer RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-01-25 03:49
 * 类描述
 * 修订历史：
 * 日期：2021-01-25
 * 作者：generator
 * 参考：
 * 描述：MeterBaseCarrierCustomer RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasecarriercustomers")
@Api(value = "/${api.version}/meterbasecarriercustomers", tags = "货代关联 - MeterBaseCarrierCustomerController")
public class MeterBaseCarrierCustomerController extends BaseRESTfulController {

    @Autowired
    IMeterBaseCarrierCustomerService meterBaseCarrierCustomerService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecarriercustomer:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCarrierCustomer> list = meterBaseCarrierCustomerService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasecarriercustomer:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseCarrierCustomer> list = meterBaseCarrierCustomerService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseCarrierCustomer对象创建")
    @ApiImplicitParam(name = "meterBaseCarrierCustomer", value = "详细实体meterBaseCarrierCustomer", required = true, dataType = "MeterBaseCarrierCustomer")
    //@RequiresPermissions("meterbasecarriercustomer:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseCarrierCustomer model) {
        try {
            MeterBaseCarrierCustomer meterBaseCarrierCustomer = meterBaseCarrierCustomerService.add(model);
            return success(meterBaseCarrierCustomer);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecarriercustomer:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseCarrierCustomer meterBaseCarrierCustomer = meterBaseCarrierCustomerService.getById(id);
            return success(meterBaseCarrierCustomer);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseCarrierCustomer信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseCarrierCustomer", value = "详细实体meterBaseCarrierCustomer", required = true, dataType = "MeterBaseCarrierCustomer")
    })
    //@RequiresPermissions("meterbasecarriercustomer:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseCarrierCustomer model) {
        try {
            model.setId(id);
            MeterBaseCarrierCustomer meterBaseCarrierCustomer = meterBaseCarrierCustomerService.modify(model);
            return success(meterBaseCarrierCustomer);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasecarriercustomer:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseCarrierCustomerService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "新增关联", notes = "根据MeterBaseCarrierCustomer对象创建")
    @ApiImplicitParam(name = "meterBaseCarrierCustomer", value = "详细实体meterBaseCarrierCustomer", required = true, dataType = "MeterBaseCarrierCustomer")
    @PostMapping(value = "relation")
    public RESTfulResult relation(@RequestBody List<MeterBaseCarrierCustomer> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterBaseCarrierCustomerService.relation(models);
            return success(num);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "解除关联", notes = "根据MeterBaseCarrierCustomer对象创建")
    @ApiImplicitParam(name = "meterBaseCarrierCustomer", value = "详细实体meterBaseCarrierCustomer", required = true, dataType = "MeterBaseCarrierCustomer")
    @PostMapping(value = "/relieve")
    public RESTfulResult relieve(@RequestBody List<MeterBaseCarrierCustomer> models) {
        RESTfulResult rm = failed();
        try {
            int num = meterBaseCarrierCustomerService.relieve(models);
            return success(num);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

}
